org.apache.tinkerpop.gremlin.process.traversal

## Interface TraversalStrategy.OptimizationStrategy

- All Superinterfaces:
    Comparable<Class<? extends TraversalStrategy>>, Serializable, TraversalStrategy<TraversalStrategy.OptimizationStrategy>
  All Known Implementing Classes:
    AdjacentToIncidentStrategy, ByModulatorOptimizationStrategy, CountStrategy, EarlyLimitStrategy, FilterRankingStrategy, GraphFilterStrategy, IdentityRemovalStrategy, IncidentToAdjacentStrategy, InlineFilterStrategy, LazyBarrierStrategy, MatchPredicateStrategy, MessagePassingReductionStrategy, OrderLimitStrategy, PathProcessorStrategy, PathRetractionStrategy, RepeatUnrollStrategy
  Enclosing interface:
    TraversalStrategy<S extends TraversalStrategy>

      public static interface TraversalStrategy.OptimizationStrategy
      extends TraversalStrategy<TraversalStrategy.OptimizationStrategy>

  Implemented by strategies that rewrite the traversal to be more efficient, but with the same semantics (e.g. `CountStrategy`). During a re-write ONLY TinkerPop steps should be used. For strategies that utilize provider specific steps, use `TraversalStrategy.ProviderOptimizationStrategy`.

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from interface org.apache.tinkerpop.gremlin.process.traversal.TraversalStrategy

      `TraversalStrategy.DecorationStrategy, TraversalStrategy.FinalizationStrategy, TraversalStrategy.OptimizationStrategy, TraversalStrategy.ProviderOptimizationStrategy, TraversalStrategy.VerificationStrategy`

  - ### Field Summary

    - ### Fields inherited from interface org.apache.tinkerpop.gremlin.process.traversal.TraversalStrategy

      `STRATEGY`

  - ### Method Summary

    All Methods Instance Methods Default Methods
    Modifier and Type | Method and Description
    --- | ---
    `default int` | `compareTo(Class<? extends TraversalStrategy> otherTraversalCategory)`
    `default Class<TraversalStrategy.OptimizationStrategy>` | `getTraversalCategory()` The type of traversal strategy -- i.e.

    - ### Methods inherited from interface org.apache.tinkerpop.gremlin.process.traversal.TraversalStrategy

      `apply, applyPost, applyPrior, getConfiguration`

- - ### Method Detail

    - #### getTraversalCategory

          default Class<TraversalStrategy.OptimizationStrategy> getTraversalCategory()

      Description copied from interface: `TraversalStrategy`
      The type of traversal strategy -- i.e. `TraversalStrategy.DecorationStrategy`, `TraversalStrategy.OptimizationStrategy`, `TraversalStrategy.FinalizationStrategy`, or `TraversalStrategy.VerificationStrategy`.
      Specified by:
        `getTraversalCategory` in interface `TraversalStrategy<TraversalStrategy.OptimizationStrategy>`
      Returns:
        the traversal strategy category class

    - #### compareTo

          default int compareTo(Class<? extends TraversalStrategy> otherTraversalCategory)

      Specified by:
        `compareTo` in interface `Comparable<Class<? extends TraversalStrategy>>`
      Specified by:
        `compareTo` in interface `TraversalStrategy<TraversalStrategy.OptimizationStrategy>`

Copyright © 2013–2021 Apache Software Foundation. All rights reserved.